package org.apache.bcel.generic;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.io.DataOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.apache.bcel.classfile.ArrayElementValue;
import org.apache.bcel.classfile.ElementValue;
import org.apache.bcel.generic.ConstantPoolGen;
import org.apache.bcel.generic.ElementValueGen;

public class ArrayElementValueGen extends ElementValueGen {
  private final List<ElementValueGen> evalues;
  
  public ArrayElementValueGen(ArrayElementValue value, ConstantPoolGen cpool, boolean copyPoolEntries) {
    super(91, cpool);
    this.evalues = new ArrayList<>();
    ElementValue[] in = value.getElementValuesArray();
    for (ElementValue element : in)
      this.evalues.add(ElementValueGen.copy(element, cpool, copyPoolEntries)); 
  }
  
  public ArrayElementValueGen(ConstantPoolGen cp) {
    super(91, cp);
    this.evalues = new ArrayList<>();
  }
  
  public ArrayElementValueGen(int type, ElementValue[] datums, ConstantPoolGen cpool) {
    super(type, cpool);
    if (type != 91)
      throw new IllegalArgumentException("Only element values of type array can be built with this ctor - type specified: " + type); 
    this.evalues = new ArrayList<>();
    for (ElementValue datum : datums)
      this.evalues.add(ElementValueGen.copy(datum, cpool, true)); 
  }
  
  public void addElement(ElementValueGen gen) {
    this.evalues.add(gen);
  }
  
  public void dump(DataOutputStream dos) throws IOException {
    dos.writeByte(getElementValueType());
    dos.writeShort(this.evalues.size());
    for (ElementValueGen element : this.evalues)
      element.dump(dos); 
  }
  
  public ElementValue getElementValue() {
    ElementValue[] immutableData = new ElementValue[this.evalues.size()];
    int i = 0;
    for (ElementValueGen element : this.evalues)
      immutableData[i++] = element.getElementValue(); 
    return new ArrayElementValue(getElementValueType(), immutableData, getConstantPool().getConstantPool());
  }
  
  public List<ElementValueGen> getElementValues() {
    return this.evalues;
  }
  
  public int getElementValuesSize() {
    return this.evalues.size();
  }
  
  public String stringifyValue() {
    StringBuilder sb = new StringBuilder();
    sb.append("[");
    String comma = "";
    for (ElementValueGen element : this.evalues) {
      sb.append(comma);
      comma = ",";
      sb.append(element.stringifyValue());
    } 
    sb.append("]");
    return sb.toString();
  }
}
